import RPi.GPIO as GPIO 
import time, re 

# DM74S471 PROM is a 256x8bit 2048bit TTL PROM

#GPIO.cleanup()
GPIO.setmode(GPIO.BCM) #Use chip numbering scheme

#G! is Chip enable 
G = 11 # GPIO out used for G!
GPIO.setup (G, GPIO.OUT) #G!

#Set the chip in standby mode:
GPIO.output(G,1) #G! - high 

#Address pins set for output A0:A7
outputs = [2,3,4,17,27,22,10,9]
for n in range(len(outputs)):
    GPIO.setup (outputs[n], GPIO.OUT)


#Data pins set for input (pull down for zeroes): Q0:Q7
inputs = [18,23,24,25,8,7,12,16]
for n in range(len(inputs)):
    GPIO.setup (inputs[n], GPIO.IN, pull_up_down = GPIO.PUD_DOWN)


def dec_to_bin(x):
    return int(bin(x)[2:])

# Set address and read memory (256bit/32 addresses)
for address in range(2**len(outputs)):
    print 'Setting Address:' + str(address)
    print (dec_to_bin(address))

    for i in range(len(outputs)):
        bitpos = i
        bit = (address >> (bitpos))&1 # Lowest bit first
        print 'Bit Posn :' + str(i) + ' value ' + str(bit)
        GPIO.output(outputs[i],bit)


    print "Turning on the chip and setting it to output mode."
    GPIO.output(G,0) #CE - low - turn on the chip
    time.sleep(0.2)

    # Read Inputs
    result = [None] * len(inputs)
    for n in range(len(inputs)):
        result[n] = GPIO.input(inputs[n])

    print result

    GPIO.output(G,1) #CE - high - standby mode

    # Write to file, print LSB - MSB left to right
    print 'Writing Result to File: romMemory_DM74S471.txt'
    with open("romMemory_DM74S471.txt","a") as myfile:
        myfile.write('Memory Address: ' + str(address) + ' Value (LSB-MSB) : '+ (''.join(str(result))))
        myfile.write('\n')

    print 'Setting Outputs to 0, cleaning up'
    # Set Address outputs to 0
    for i in range(len(outputs)):
        GPIO.output(outputs[i],0)


myfile.close()
GPIO.cleanup()
print 'Done'
